'''Game main module.

DIS IS MY GAME!
By Eugman
'''

import pyglet,math, copy
from pyglet.window import key
from pyglet.window import mouse



##functions
def lerp(old,new,p):
    
    return [x*(1-p)+y*p for x,y in zip(old,new)]
        
            
def tog(x):
    """Converts an x or a y to the grid number"""
    return (x+20)//40

def drawsquare((x,y),(l,w),color):
    pyglet.graphics.draw(4,pyglet.gl.GL_QUADS,('v2f',(x-l,y-w,x+l,y-w,x+l,y+w,x-l,y+w)),
        ('c4B', color*4))
    

def typecolor(t):
    return (200,200,100,245)
    
    
def convert(conv):
    if conv.HASBOX:
        conv.ends=(1,1,1,1)
        conv.HASBOX=False
    elif conv.ends in ((1,0,1,0),(0,1,0,1)):
        conv.ends=(1,1,0,0)
    elif conv.ends in ((1,1,0,0),(0,1,1,0),(0,0,1,1),(1,0,0,1)):
        conv.ends=(1,1,0,1)
    elif conv.ends in ((1,1,0,1),(1,1,1,0),(0,1,1,1),(1,0,1,1)):
        conv.HASBOX=True
    elif conv.ends==(1,1,1,1):
        conv.ends=(1,0,1,0)
    
        
    
def connected(start,end,(x,y)):
    if x:
        if x==1:
            return start.ends[1] and end.ends[3]
        else:
            return start.ends[3] and end.ends[1]
    elif y:
        if y==1:
            return start.ends[0] and end.ends[2]
        else:
            return start.ends[2] and end.ends[0]


##Classes
         

class square(object):
    def __init__(self,pos,(x,y)):
        self.vel=[0,-1]
        self.pos=pos
        self.oldpos=pos[:]
        self.lw=[x,y]
        self.color=(200,200,128,255)
        self.ticks=0
    def draw(self):
        drawsquare(lerp(self.oldpos,self.pos,self.ticks/30.0),self.lw,self.color)
    def update(self,dt,ticks):
        self.ticks=ticks
    def move(self,x,y):
         self.pos[0]+=x
         self.pos[1]+=y

class conveyor(object):
    def __init__(self):
        self.ends=(1,0,1,0)
        self.color=(255,255,255,255)
        self.pos=[-100,-100]
        self.HASBOX=False
        self.full=0
    def draw(self):
        
        if self.HASBOX:
            drawsquare(self.pos,(15,15),(75,75,25,255))
        for i in range(4):
            if self.ends[i]:
                if i%2:
                    #Right or Left
                    l=11
                    w=2.5
                    x=self.pos[0]+(i-2)*9
                    y=self.pos[1]
                else:
                    #Top or bottom
                    l=2.5
                    w=11
                    x=self.pos[0]
                    y=self.pos[1]+(i-1)*-9
                pyglet.graphics.draw(4,pyglet.gl.GL_QUADS,('v2f',(x-l,y-w,x+l,y-w,x+l,y+w,x-l,y+w)),('c4B', self.color*4))
    def update(self,dt,ticks):
        pass
    def rotate(self,direction):
        if direction==1:
            self.ends=self.ends[-1:]+self.ends[:-1]
        elif direction==-1:
            self.ends=self.ends[1:]+self.ends[:1]

class input:
    def __init__(self):
        self.type=1
        self.color=typecolor(self.type)

class output:
    def __init__(self):
        pass
#######################
##Main
########################33
def main():
    

    grid=[[[] for x in xrange(14)] for x in xrange(10)]
    blocks=[[[] for x in xrange(14)] for x in xrange(10)]
    
    blocks[5][10]=square([5*40+240,10*40+40],(10,10))
    
    window=pyglet.window.Window(800,600,"Quadrangles of Fury")
    window.clear()
    mouseblock=conveyor()
    overlay=square([-100,-100],[20,20])
    
    pyglet.ticks=0
    
    pyglet.gl.glBlendFunc(pyglet.gl.GL_SRC_ALPHA, pyglet.gl.GL_ONE_MINUS_SRC_ALPHA)
    pyglet.gl.glEnable(pyglet.gl.GL_BLEND)
    
    @window.event
    def on_key_press(symbol,modifiers):
        if symbol==key.A:
            mouseblock.rotate(-1)
        if symbol==key.D:
            mouseblock.rotate(1)
        if symbol==key.W:
            convert(mouseblock)
        elif symbol==key.S:
            convert(mouseblock)
            convert(mouseblock)
            convert(mouseblock)
            convert(mouseblock)
    
    @window.event
    def on_mouse_press(x, y, button, modifiers):
        if 0<tog(x)-6<=8 and 0<tog(y)-1<=12:
            if button==mouse.LEFT:
                if not grid[tog(x)-6][tog(y)-1]:
                    grid[tog(x)-6][tog(y)-1]=copy.copy(mouseblock)
            if button==mouse.RIGHT:
                grid[tog(x)-6][tog(y)-1]=0

    @window.event
    def on_mouse_motion(x,y,dx,dy):
        mouseblock.pos=[40*(tog(x)),40*(tog(y))]
        overlay.pos=mouseblock.pos
    ##################3
    ##DRAW
    ###################3
  
    @window.event
    def on_draw():
        window.clear()
        drawsquare((400,300),(400,300),(20,20,50,255))
        drawsquare((420,300),(160,240),(75,173,75,255))
        drawsquare((420,560),(160,20),(0,20,0,255))
        drawsquare((420,40),(160,20),(0,20,0,255))
        
        
        for i in range(len(grid)):
            for j in range(len(grid[i])):
                if grid[i][j]: 
                    grid[i][j].draw()
                else: 
                    if 0<i<=8:
                        drawsquare((i*40+240,j*40+40),(20,20),(50+i,50+j,50+i+j,128))
        for i in blocks:
            for j in i:
                if j:j.draw()
        if 0<tog(mouseblock.pos[0])-6<=8 and 0<=tog(mouseblock.pos[1])-1<=13:
            overlay.draw()
            mouseblock.draw()
    
    ##################33
    #UPDATE
    ####################3
    
    
    def update(dt):
        pyglet.ticks+=1
        pyglet.ticks%=31
    
        for i in range(len(grid)):
            for j in range(len(grid[i])):
                #if grid[i][j]: grid[i][j].update(dt)
                if blocks[i][j]:
                    blocks[i][j].update(dt,pyglet.ticks)
                if blocks[i][j] and grid[i][j]:
                    x,y=blocks[i][j].vel
                    if pyglet.ticks==0  :
                        if grid[i+x][j+y] and not grid[i+x][j+y].full and connected(grid[i][j],grid[i+x][j+y],(x,y)):
                            blocks[i][j].oldpos=blocks[i][j].pos[:]
                            blocks[i][j].pos[0]+=40*x
                            blocks[i][j].pos[1]+=40*y
                            blocks[i+x][j+y]=copy.copy(blocks[i][j])
                            blocks[i][j]=0
                            grid[i][j].full=0
                        else:
                            blocks[i][j].oldpos=blocks[i][j].pos[:]
                
                    
        if  not 0<tog(mouseblock.pos[0])-6<=8 or  not 0<tog(mouseblock.pos[1])-1<=12 or\
         grid[tog(mouseblock.pos[0])-6][tog(mouseblock.pos[1])-1]:
            overlay.color=(250,100,100,200)
        else:
            overlay.color=(128,128,255,96) 
                
        
        
                
                
                
    pyglet.clock.schedule_interval(update, 1/30.)
    pyglet.app.run()

if __name__ == '__main__':
    main()
